Index: trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp
===================================================================
--- trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 585)
+++ trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 712)
@@ -1884,55 +2161,29 @@
     //////////////////////////////////////////////////////////////
     // DMA_RSP fifo update
-    // Two writers : DMA_CMD FSM & DMA_RSP FSM
+    // writer : DMA_RSP FSM
     //////////////////////////////////////////////////////////////
 
-    if (r_alloc_fifo_dma_rsp_local.read() )  // owner is DMA_CMD FSM
-                                             // local response for a translation error
-    {
-        m_dma_rsp_data_fifo.update(   dma_rsp_fifo_get,
-                                      dma_rsp_fifo_put,
-                                      0 );                      // no data if error
-        m_dma_rsp_rsrcid_fifo.update( dma_rsp_fifo_get,
-                                      dma_rsp_fifo_put,
-                                      p_vci_tgt_iox.rsrcid.read() ); 
-        m_dma_rsp_rtrdid_fifo.update( dma_rsp_fifo_get,
-                                      dma_rsp_fifo_put,
-                                      p_vci_tgt_iox.rtrdid.read() ); 
-        m_dma_rsp_rpktid_fifo.update( dma_rsp_fifo_get,
-                                      dma_rsp_fifo_put,
-                                      p_vci_tgt_iox.rpktid.read() ); 
-        m_dma_rsp_reop_fifo.update(   dma_rsp_fifo_get,
-                                      dma_rsp_fifo_put,
-                                      true );                    // single flit response
-        m_dma_rsp_rerror_fifo.update( dma_rsp_fifo_get,
-                                      dma_rsp_fifo_put,
-                                      1 );                        // error
-    }
-    else                                   // owner is DMA_RSP FSM
-                                           // normal response to a DMA transaction
-    {
-        m_dma_rsp_data_fifo.update(   dma_rsp_fifo_get,
-                                      dma_rsp_fifo_put,
-                                      p_vci_ini_ram.rdata.read() );
-        m_dma_rsp_rsrcid_fifo.update( dma_rsp_fifo_get,
-                                      dma_rsp_fifo_put,
-                                      p_vci_ini_ram.rsrcid.read() );
-        m_dma_rsp_rtrdid_fifo.update( dma_rsp_fifo_get,
-                                      dma_rsp_fifo_put,
-                                      p_vci_ini_ram.rtrdid.read() );
-        m_dma_rsp_rpktid_fifo.update( dma_rsp_fifo_get,
-                                      dma_rsp_fifo_put,
-                                      p_vci_ini_ram.rpktid.read() );
-        m_dma_rsp_reop_fifo.update(   dma_rsp_fifo_get,
-                                      dma_rsp_fifo_put,
-                                      p_vci_ini_ram.reop.read() );
-        m_dma_rsp_rerror_fifo.update( dma_rsp_fifo_get,
-                                      dma_rsp_fifo_put,
-                                      p_vci_ini_ram.rerror.read() );
-    }
+    m_dma_rsp_data_fifo.update(   dma_rsp_fifo_get,
+                                  dma_rsp_fifo_put,
+                                  dma_rsp_fifo_rdata );
+    m_dma_rsp_rsrcid_fifo.update( dma_rsp_fifo_get,
+                                  dma_rsp_fifo_put,
+                                  dma_rsp_fifo_rsrcid ); 
+    m_dma_rsp_rtrdid_fifo.update( dma_rsp_fifo_get,
+                                  dma_rsp_fifo_put,
+                                  dma_rsp_fifo_rtrdid ); 
+    m_dma_rsp_rpktid_fifo.update( dma_rsp_fifo_get,
+                                  dma_rsp_fifo_put,
+                                  dma_rsp_fifo_rpktid ); 
+    m_dma_rsp_reop_fifo.update(   dma_rsp_fifo_get,
+                                  dma_rsp_fifo_put,
+                                  dma_rsp_fifo_reop );     
+    m_dma_rsp_rerror_fifo.update( dma_rsp_fifo_get,
+                                  dma_rsp_fifo_put,
+                                  dma_rsp_fifo_rerror );
 
     ////////////////////////////////////////////////////////////////
     // CONFIG_CMD fifo update
-    // One writer : CONFIG_CMD FSM
+    // writer : CONFIG_CMD FSM
     ////////////////////////////////////////////////////////////////
 
@@ -1982,89 +2233,84 @@
     //////////////////////////////////////////////////////////////////////////
     // CONFIG_RSP fifo update
-    // There is two writers : CONFIG_CMD FSM & CONFIG_RSP FSM
+    // writer : CONFIG_RSP FSM
     //////////////////////////////////////////////////////////////////////////
 
-    if ( r_alloc_fifo_config_rsp_local.read() )  // owner is CONFIG_CMD FSM
-                                                 // response for a local config transaction 
-    {
-        m_config_rsp_data_fifo.update(   config_rsp_fifo_get,
-                                         config_rsp_fifo_put,
-                                         r_config_cmd_rdata.read() ); 
-        m_config_rsp_rsrcid_fifo.update( config_rsp_fifo_get,
-                                         config_rsp_fifo_put,
-                                         p_vci_tgt_int.srcid.read() );
-        m_config_rsp_rtrdid_fifo.update( config_rsp_fifo_get,
-                                         config_rsp_fifo_put,
-                                         p_vci_tgt_int.trdid.read() );
-        m_config_rsp_rpktid_fifo.update( config_rsp_fifo_get,
-                                         config_rsp_fifo_put,
-                                         p_vci_tgt_int.pktid.read() );
-        m_config_rsp_reop_fifo.update(   config_rsp_fifo_get,
-                                         config_rsp_fifo_put,
-                                         true );                // local config are one flit
-        m_config_rsp_rerror_fifo.update( config_rsp_fifo_get,
-                                         config_rsp_fifo_put,
-                                         r_config_cmd_error.read() );
-    }
-    else                                         // owner is CONFIG_RSP FSM
-                                                 // response for a remote transaction
-    {
-        // PUT  depends on CONFIG_RSP FSM state 
-        uint32_t rdata;
-        bool     reop;
-        if ( r_config_rsp_fsm.read() == CONFIG_RSP_PUT_HI )
-        {
-            config_rsp_fifo_put = true;
-            rdata               = (uint32_t)(p_vci_ini_iox.rdata.read()>>32);
-            reop                = p_vci_ini_iox.reop.read(); 
-        }
-        else if ( r_config_rsp_fsm.read() == CONFIG_RSP_PUT_LO )
-        {
-            config_rsp_fifo_put = true;
-            rdata               = (uint32_t)(p_vci_ini_iox.rdata.read());
-            reop                = false;
-        }
-        else if ( r_config_rsp_fsm.read() == CONFIG_RSP_PUT_UNC )
-        {
-            config_rsp_fifo_put = true;
-            rdata               = (uint32_t)(p_vci_ini_iox.rdata.read());
-            reop                = true;
-        }
-        else
-        {
-            config_rsp_fifo_put = false;
-            rdata               = 0;
-            reop                = false;;
-        }
-
-        m_config_rsp_data_fifo.update(   config_rsp_fifo_get,
-                                         config_rsp_fifo_put,
-                                         rdata );
-        m_config_rsp_rsrcid_fifo.update( config_rsp_fifo_get,
-                                         config_rsp_fifo_put,
-                                         p_vci_ini_iox.rsrcid.read() );
-        m_config_rsp_rtrdid_fifo.update( config_rsp_fifo_get,
-                                         config_rsp_fifo_put,
-                                         p_vci_ini_iox.rtrdid.read() );
-        m_config_rsp_rpktid_fifo.update( config_rsp_fifo_get,
-                                         config_rsp_fifo_put,
-                                         p_vci_ini_iox.rpktid.read() );
-        m_config_rsp_reop_fifo.update(   config_rsp_fifo_get,
-                                         config_rsp_fifo_put,
-                                         reop );
-        m_config_rsp_rerror_fifo.update( config_rsp_fifo_get,
-                                         config_rsp_fifo_put,
-                                         p_vci_ini_iox.rerror.read() );
-    }
+    m_config_rsp_data_fifo.update(   config_rsp_fifo_get,
+                                     config_rsp_fifo_put,
+                                     config_rsp_fifo_rdata ); 
+    m_config_rsp_rsrcid_fifo.update( config_rsp_fifo_get,
+                                     config_rsp_fifo_put,
+                                     config_rsp_fifo_rsrcid );
+    m_config_rsp_rtrdid_fifo.update( config_rsp_fifo_get,
+                                     config_rsp_fifo_put,
+                                     config_rsp_fifo_rtrdid );
+    m_config_rsp_rpktid_fifo.update( config_rsp_fifo_get,
+                                     config_rsp_fifo_put,
+                                     config_rsp_fifo_rpktid );
+    m_config_rsp_reop_fifo.update(   config_rsp_fifo_get,
+                                     config_rsp_fifo_put,
+                                     config_rsp_fifo_reop );
+    m_config_rsp_rerror_fifo.update( config_rsp_fifo_get,
+                                     config_rsp_fifo_put,
+                                     config_rsp_fifo_rerror );
+      
+    ////////////////////////////////////////////////////////////////
+    // MISS_WTI_CMD fifo update
+    // One writer : MISS_WTI switch
+    ////////////////////////////////////////////////////////////////
+
+    m_miss_wti_cmd_addr_fifo.update(   miss_wti_cmd_fifo_get,
+                                       miss_wti_cmd_fifo_put,
+                                       miss_wti_cmd_fifo_address ); 
+    m_miss_wti_cmd_cmd_fifo.update(    miss_wti_cmd_fifo_get,
+                                       miss_wti_cmd_fifo_put,
+                                       miss_wti_cmd_fifo_cmd ); 
+    m_miss_wti_cmd_contig_fifo.update( config_cmd_fifo_get,
+                                       miss_wti_cmd_fifo_put,
+                                       true );
+    m_miss_wti_cmd_cons_fifo.update(   miss_wti_cmd_fifo_get,
+                                       miss_wti_cmd_fifo_put,
+                                       false );
+    m_miss_wti_cmd_plen_fifo.update(   miss_wti_cmd_fifo_get,
+                                       miss_wti_cmd_fifo_put,
+                                       4 );
+    m_miss_wti_cmd_wrap_fifo.update(   miss_wti_cmd_fifo_get,
+                                       miss_wti_cmd_fifo_put,
+                                       false );
+    m_miss_wti_cmd_cfixed_fifo.update( config_cmd_fifo_get,
+                                       miss_wti_cmd_fifo_put,
+                                       false );
+    m_miss_wti_cmd_clen_fifo.update(   miss_wti_cmd_fifo_get,
+                                       miss_wti_cmd_fifo_put,
+                                       0 );
+    m_miss_wti_cmd_srcid_fifo.update(  miss_wti_cmd_fifo_get,
+                                       miss_wti_cmd_fifo_put,
+                                       miss_wti_cmd_fifo_srcid );
+    m_miss_wti_cmd_trdid_fifo.update(  miss_wti_cmd_fifo_get,
+                                       miss_wti_cmd_fifo_put,
+                                       miss_wti_cmd_fifo_trdid );
+    m_miss_wti_cmd_pktid_fifo.update(  miss_wti_cmd_fifo_get,
+                                       miss_wti_cmd_fifo_put,
+                                       miss_wti_cmd_fifo_pktid );
+    m_miss_wti_cmd_data_fifo.update(   miss_wti_cmd_fifo_get,
+                                       miss_wti_cmd_fifo_put,
+                                       miss_wti_cmd_fifo_wdata );
+    m_miss_wti_cmd_be_fifo.update(     miss_wti_cmd_fifo_get,
+                                       miss_wti_cmd_fifo_put,
+                                       0xF );
+    m_miss_wti_cmd_eop_fifo.update(    miss_wti_cmd_fifo_get,
+                                       miss_wti_cmd_fifo_put,
+                                       true );
     
 } // end transition()
 
-///////////////////////
+//////////////////////////////////////////////////////////////////////////
 tmpl(void)::genMoore()
-///////////////////////
+//////////////////////////////////////////////////////////////////////////
 {
+    /////////////////  p_vci_ini_ram  /////////////////////////////
+
     // VCI initiator command on RAM network
     // directly the content of the dma_cmd FIFO
-
     p_vci_ini_ram.cmdval  = m_dma_cmd_addr_fifo.rok(); 
     p_vci_ini_ram.address = m_dma_cmd_addr_fifo.read();
@@ -2083,27 +2329,13 @@
     p_vci_ini_ram.srcid   = m_dma_cmd_srcid_fifo.read();
     
-    // VCI target command ack on IOX network
-    // depends on the DMA_CMD FSM state
-
-    switch ( r_dma_cmd_fsm.read() ) 
-    {
-    case DMA_CMD_IDLE:
-    case DMA_CMD_MISS_WAIT:
-        p_vci_tgt_iox.cmdack  = false;
-        break;
-    case DMA_CMD_WAIT_EOP:
-        p_vci_tgt_iox.cmdack  = true;
-        break;
-    case DMA_CMD_FIFO_PUT_CMD:
-        p_vci_tgt_iox.cmdack  = m_dma_cmd_addr_fifo.wok();
-        break;
-    case DMA_CMD_FIFO_PUT_RSP:
-        p_vci_tgt_iox.cmdack  = m_dma_rsp_data_fifo.wok();
-        break; 
-    }
-
-    // VCI target response on IOX network
+    // VCI initiator response on the RAM Network
+    // depends on the DMA_RSP FSM state
+   	p_vci_ini_ram.rspack = m_dma_rsp_data_fifo.wok() and
+                           (r_dma_rsp_fsm.read() == DMA_RSP_PUT_DMA); 
+
+    /////////////////  p_vci_tgt_iox  /////////////////////////////
+
+    // VCI target response on IOX network is
     // directly the content of the DMA_RSP FIFO
-
     p_vci_tgt_iox.rspval  = m_dma_rsp_data_fifo.rok();
     p_vci_tgt_iox.rsrcid  = m_dma_rsp_rsrcid_fifo.read();
@@ -2114,14 +2346,35 @@
     p_vci_tgt_iox.reop    = m_dma_rsp_reop_fifo.read();
 
-    // VCI initiator response on the RAM Network
-    // depends on the DMA_RSP FSM state
-
-   	p_vci_ini_ram.rspack = m_dma_rsp_data_fifo.wok() and
-                           (r_dma_rsp_fsm.read() == DMA_RSP_FIFO_PUT) and 
-                           not r_alloc_fifo_dma_rsp_local.read();
-
-    // VCI initiator command on IOX network
+    // VCI target command ack on IOX network
+    // depends on the DMA_CMD FSM state
+    switch ( r_dma_cmd_fsm.read() ) 
+    {
+        case DMA_CMD_IDLE:             
+             p_vci_tgt_iox.cmdack  = false; 
+             break;
+        case DMA_CMD_DMA_REQ:
+             p_vci_tgt_iox.cmdack  = m_dma_cmd_addr_fifo.wok(); 
+             break;
+        case DMA_CMD_WTI_IOX_REQ:
+             p_vci_tgt_iox.cmdack  = not r_dma_cmd_to_miss_wti_cmd_req.read(); 
+             break;
+        case DMA_CMD_ERR_WTI_REQ:
+             p_vci_tgt_iox.cmdack  = false; 
+             break;
+        case DMA_CMD_ERR_WAIT_EOP: 
+             p_vci_tgt_iox.cmdack  = true;  
+             break;
+        case DMA_CMD_ERR_RSP_REQ: 
+             p_vci_tgt_iox.cmdack  = false;  
+             break;
+        case DMA_CMD_TLB_MISS_WAIT: 
+             p_vci_tgt_iox.cmdack  = false;  
+             break;
+    }
+
+    //////////////////  p_vci_ini_iox  /////////////////////////////
+
+    // VCI initiator command on IOX network is
     // directly the content of the CONFIG_CMD FIFO
-
     p_vci_ini_iox.cmdval  = m_config_cmd_addr_fifo.rok();
     p_vci_ini_iox.address = m_config_cmd_addr_fifo.read();
@@ -2140,7 +2393,24 @@
     p_vci_ini_iox.srcid   = m_config_cmd_srcid_fifo.read();
     
+    // VCI initiator response on IOX Network
+    // it depends on the CONFIG_RSP FSM state
+   	p_vci_ini_iox.rspack = m_config_rsp_data_fifo.wok() and 
+                           ( (r_config_rsp_fsm.read() == CONFIG_RSP_PUT_UNC) or
+                             (r_config_rsp_fsm.read() == CONFIG_RSP_PUT_HI) );
+
+    /////////////////  p_vci_tgt_int  ////////////////////////////////
+
+    // VCI target response on INT network
+    // directly the content of the CONFIG_RSP FIFO
+    p_vci_tgt_int.rspval  = m_config_rsp_data_fifo.rok();
+	p_vci_tgt_int.rsrcid  = m_config_rsp_rsrcid_fifo.read();
+    p_vci_tgt_int.rtrdid  = m_config_rsp_rtrdid_fifo.read();
+    p_vci_tgt_int.rpktid  = m_config_rsp_rpktid_fifo.read();
+    p_vci_tgt_int.rdata   = m_config_rsp_data_fifo.read();
+    p_vci_tgt_int.rerror  = m_config_rsp_rerror_fifo.read();
+    p_vci_tgt_int.reop    = m_config_rsp_reop_fifo.read();
+    
     // VCI target command ack on INT network
     // it depends on the CONFIG_CMD FSM state
-
     switch ( r_config_cmd_fsm.read() ) 
     {
@@ -2159,74 +2429,39 @@
     }
 
-    // VCI target response on INT network
-    // directly the content of the CONFIG_RSP FIFO
-
-    p_vci_tgt_int.rspval  = m_config_rsp_data_fifo.rok();
-	p_vci_tgt_int.rsrcid  = m_config_rsp_rsrcid_fifo.read();
-    p_vci_tgt_int.rtrdid  = m_config_rsp_rtrdid_fifo.read();
-    p_vci_tgt_int.rpktid  = m_config_rsp_rpktid_fifo.read();
-    p_vci_tgt_int.rdata   = m_config_rsp_data_fifo.read();
-    p_vci_tgt_int.rerror  = m_config_rsp_rerror_fifo.read();
-    p_vci_tgt_int.reop    = m_config_rsp_reop_fifo.read();
-    
-    // VCI initiator response on IOX Network
-    // it depends on the CONFIG_RSP FSM state
-
-   	p_vci_ini_iox.rspack = m_config_rsp_data_fifo.wok() and 
-                           not r_alloc_fifo_config_rsp_local.read() and
-                           ( (r_config_rsp_fsm.read() == CONFIG_RSP_PUT_UNC) or
-                             (r_config_rsp_fsm.read() == CONFIG_RSP_PUT_HI) );
+    /////////////////  p_vci_ini_int  ////////////////////////////////
 
     // VCI initiator command  on INT network 
-    // it depends on the MISS_WTI_CMD FSM state   
-    // - WTI : single flit WRITE
-    // - MISS TLB : multi-flit READ for a complete cache line
-
-    // default values
-    p_vci_ini_int.srcid   = m_int_srcid;
-    p_vci_ini_int.trdid   = 0;
-    p_vci_ini_int.cfixed  = false;
-    p_vci_ini_int.eop     = true;
-    p_vci_ini_int.wrap    = false;
-    p_vci_ini_int.clen    = 0;
-    p_vci_ini_int.contig  = true;
-    p_vci_ini_int.cons    = false;
-    p_vci_ini_int.be      = 0xF;
-    
-    switch ( r_miss_wti_cmd_fsm.read() ) 
-    {   
-    case MISS_WTI_CMD_IDLE:
-		p_vci_ini_int.cmdval  = false;
-        p_vci_ini_int.address = 0;
-        p_vci_ini_int.cmd     = vci_param_int::CMD_NOP;
-        p_vci_ini_int.pktid   = PKTID_READ;
-        p_vci_ini_int.wdata   = 0;
-        p_vci_ini_int.plen    = 0;
-        break;
-    
-    case MISS_WTI_CMD_WTI:
-        p_vci_ini_int.cmdval  = true;
-        p_vci_ini_int.address = r_iommu_peri_wti[r_miss_wti_cmd_index.read()].read(); 
-        p_vci_ini_int.cmd     = vci_param_int::CMD_WRITE;
-        p_vci_ini_int.pktid   = PKTID_WRITE;
-        p_vci_ini_int.wdata   = (int_data_t)r_irq_pending[r_miss_wti_cmd_index.read()].read();
-        p_vci_ini_int.plen    = vci_param_int::B;
-        break;
-    
-    case MISS_WTI_CMD_MISS:
-        p_vci_ini_int.cmdval  = true;
-        p_vci_ini_int.address = r_tlb_paddr.read() & CACHE_LINE_MASK;
-        p_vci_ini_int.cmd     = vci_param_int::CMD_READ;
-        p_vci_ini_int.pktid   = PKTID_READ;
-        p_vci_ini_int.wdata   = 0;
-        p_vci_ini_int.plen    = m_words*(vci_param_int::B);
-        break;
-    }
+    // directly the content of the MISS_WTI_CMD FIFO  
+    p_vci_ini_int.cmdval  = m_miss_wti_cmd_addr_fifo.rok();
+    p_vci_ini_int.address = m_miss_wti_cmd_addr_fifo.read();
+    p_vci_ini_int.be      = m_miss_wti_cmd_be_fifo.read();
+    p_vci_ini_int.cmd     = m_miss_wti_cmd_cmd_fifo.read();
+    p_vci_ini_int.contig  = m_miss_wti_cmd_contig_fifo.read();
+    p_vci_ini_int.wdata   = m_miss_wti_cmd_data_fifo.read(); 
+    p_vci_ini_int.eop     = m_miss_wti_cmd_eop_fifo.read();
+    p_vci_ini_int.cons    = m_miss_wti_cmd_cons_fifo.read();
+    p_vci_ini_int.plen    = m_miss_wti_cmd_plen_fifo.read();
+    p_vci_ini_int.wrap    = m_miss_wti_cmd_wrap_fifo.read();
+    p_vci_ini_int.cfixed  = m_miss_wti_cmd_cfixed_fifo.read();
+    p_vci_ini_int.clen    = m_miss_wti_cmd_clen_fifo.read();
+    p_vci_ini_int.trdid   = m_miss_wti_cmd_trdid_fifo.read();
+    p_vci_ini_int.pktid   = m_miss_wti_cmd_pktid_fifo.read();
+    p_vci_ini_int.srcid   = m_miss_wti_cmd_srcid_fifo.read();
 
     // VCI initiator response on INT network
     // It depends on the MISS_WTI_RSP FSM state
 
-    if ( r_miss_wti_rsp_fsm.read() == MISS_WTI_RSP_IDLE ) p_vci_ini_int.rspack  = false;
-    else                                                  p_vci_ini_int.rspack  = true;
+    if ( r_miss_wti_rsp_fsm.read() == MISS_WTI_RSP_IDLE )
+    {
+        p_vci_ini_int.rspack = false;
+    }
+    else if ( r_miss_wti_rsp_fsm.read() == MISS_WTI_RSP_WTI_IOX )
+    {
+        p_vci_ini_int.rspack = not r_miss_wti_rsp_to_dma_rsp_req.read();
+    }
+    else  //  MISS_WTI_RSP_MISS or MISS_WTI_RESP_WTI_MMU
+    {
+        p_vci_ini_int.rspack = true;
+    }
 
 } // end genMoore
